.nolist

.Model small	
.Stack 512
.386			; you could indeed use 32-bit regs

Init MACRO
.code
start:
  mov ax, @DATA	; set the DS register to DGROUP
  mov ds, ax		; for ds:si (lods)
  mov es, ax		; for es:di (scas, stos)
ENDM

Exit MACRO ExCode:=<0>
  mov ax, 4C00h+ExCode	; the DOS equivalent to ExitProcess
  int 21h
ENDM

Chr$ MACRO any_text:VARARG
LOCAL txtname
.data
	txtname db any_text, 0
.code
	EXITM <OffSET txtname>
ENDM

Inkey MACRO args:VARARG
  ifnb <args>
	Print args
  endif
  mov ah, 0		; wait for a key
  int 16h
ENDM

Str$ MACRO arg
LOCAL slbl
  ifndef NumToAscii
	.DATA?
	NumBuf db 10 dup(?)
	.CODE
	jmp slbl
	NumToAscii: 	; Number:WORD
		pop dx
		pop ax	; get number from stack
		push dx
		push si
		push cx
		mov si, offset NumBuf+9
		mov byte ptr [si], 0
		mov cx, 10
	
		StringCreateLoop:
		xor dx, dx
		div cx
		add dx, '0'
		dec si
		mov byte ptr [si], dl
		test ax, ax
		jnz StringCreateLoop
		xchg ax, si
		pop cx
		pop si
		retn
;	aka NumToAscii endp
	slbl:
  endif
  if type arg eq BYTE
	movsx ax, arg
	push ax
  else
	push arg
  endif
  call NumToAscii
  EXITM <ax>
ENDM

Hex$ MACRO arg
  ifndef MbHexBuffer
	.data?
	MbHexBuffer db 6 dup(?)
	.code
  endif
  push cx
  push bx
  if type arg eq BYTE
	movsx ax, arg
	mov bx, offset MbHexBuffer+1
  else
	ifdifi <ax>, <arg>
		mov ax, arg
	endif
	mov bx, offset MbHexBuffer+2+1
  endif
  mov byte ptr [bx+1], 0
  dec bx
@@:
  mov dl, al	; first nibble
  and dl, 15
  add dl, "0"
  .if dl>"9"
	add dl, 7
  .endif
  shr al, 4	; second nibble
  and al, 15
  add al, "0"
  .if al>"9"
	add al, 7
  .endif
  push ax
  mov ah, dl	; join the nibbles
  mov [bx], ax
  pop ax
  shr ax, 8
  sub bx, 2
  cmp bx, offset MbHexBuffer
  jge @B
;  mov dx, bx	; retval edx for Print and Let
  pop bx
  pop cx
  EXITM <offset MbHexBuffer>
ENDM

Open MACRO mc:REQ, fnu:REQ, fname:REQ
LOCAL fnu2
  fnu2 SUBSTR <fnu>, 2
  ifndef MbFH
	.data?
	MbFH dw 10 dup(?)	; Mb file handles, 0-9
	.code
  endif
  mov dx, reparg(fname)
  ifidni <mc>,<"i">
	mov ax, 3D20h	; ah=3Dh, al=20h aka read-only
  else
	mov ah, 3Ch	; ah=3Ch, al=?
	xor cx, cx	; attribute normal
  endif
  int 21h
  mov MbFH[2*fnu2], ax
ENDM

Close MACRO fnu:REQ
  LOCAL fnu2
  fnu2  SUBSTR <fnu>, 1, 1
  ifidn fnu2,<#>
	fnu2 SUBSTR <fnu>, 2
  endif
  push bx
  mov bx, MbFH[2*fnu2]
  mov AH, 3Eh
  int 21h
  pop bx
ENDM

Print MACRO arg1:REQ, moreargs:VARARG
LOCAL qu, fnu2
  ifndef pr16P
	.code
	jmp plbl
	pr16P::
	push cx
	push bp
	push di
	push bx
	mov bp, sp
	mov di, [bp+10]	; arg1
	mov bx, [bp+12]	; arg2
	mov ax, 4000h
	push di
	or cx, -1
	repne scasb
	neg cx
	sub cx, 2
	pop dx
	int 21h			; 40h expects bx, cx and dx
	pop bx
	pop di
	pop bp
	pop cx
	retn 4
	plbl:
  endif
  fnu2  SUBSTR <arg1>, 1, 1
  ifidn fnu2,<#>
	fnu2 SUBSTR <arg1>, 2
	push MbFH[2*fnu2]
	push reparg(moreargs)
	call pr16P
  else
	push 1		; STDOUT
	push reparg(arg1)
	call pr16P
	ifnb <moreargs>
		push 1
		push reparg(moreargs)
		call pr16P
	endif
  endif
ENDM

reparg Macro string:VARARG
LOCAL is, nustr, arg
  is INSTR 2, <string>, <">
  ife is
	is INSTR 2, <string>, <'>
  endif
  ife is
	FOR arg, <string>
		is = opattr arg
		EXiTM
	ENDM
	if is ne 36
		is = 0
	endif
  endif
  if is
	.data
	nustr db string, 0
	.code
	EXITM <offset nustr>
  else
	EXITM <string>
  endif
ENDM

FileRead MACRO dest, fname
LOCAL pBuffer, nocr
  pBuffer CATSTR <mkp>, <dest>
  % ifndef pBuffer
	% echo dest is not a valid buffer
	.err
  endif
  nocr=0
  push bx
  push cx
  ifidni <fname>, <"con:">
	mov dx, reparg("CON")	; correct syntax
	nocr=-2
  else
	mov dx, reparg(fname)
	ifidni <fname>, <"con">
		nocr=-2
	endif
  endif
  mov ax, 3D20h	; ah=3Dh, al=20h aka read-only
  int 21h
  .if !Carry?
	mov bx, ax	; BX = file handle
	mov cx, SIZEOF pBuffer	; CX = number of bytes to read
	mov dx, dest	; buffer
	push dx
	mov ax, 3Fh*256	; Read
	int 21h
	pop bx
	add bx, ax
	mov byte ptr [bx+nocr], 0
  .endif
  pop cx
  pop bx
ENDM

MkBytes = 0
Make$ MACRO TheName, Bytes
LOCAL pBuffer, oa, tmp$
  oa = opattr Bytes
  if oa ne 36
	tmp$ equ <only immediates allowed ##>
  elseif Bytes+MkBytes gt 65000
	tmp$ equ <max size is 64K ##>
  endif
  ifdef tmp$
	% echo ## Make$ TheName, Bytes: tmp$
	.err
	EXITM
  endif
  MkBytes = MkBytes + Bytes
  pBuffer CATSTR <mkp>, <TheName>
.data?
pBuffer	db Bytes dup(?)
.data
TheName	dw pBuffer
.code
ENDM

Time$ MACRO
  ifndef pTime$
	.data?
	pTime$	db 6 dup(?)
	.code
  endif
  mov ah, 2Ch	; GET SYSTEM TIME
  int 21h
  pusha
  add ch, 100
  mov si, Str$(ch)
  lodsb
  mov di, offset pTime$
  movsb
  movsb
  mov al, ":"
  stosb
  add cl, 100
  mov si, Str$(cl)
  lodsb
  movsb
  movsb
  xor al, al
  stosb
  popa
  EXITM <offset pTime$>
ENDM

Input$ MACRO prompt:VARARG	; Let esi="["+Input$("Type something and hit Enter: ")+"]"
  ifndef ipdef$
	Make$ ipdef$, 100
  endif
  Print prompt
  FileRead ipdef$, "CON"
  EXITM <offset mkpipdef$>
ENDM
